
import UIKit
import CoreGraphics

import WebKit


extension UIScreen {
    
    public static func ft_width() -> CGFloat {
        return self.main.bounds.size.width
    }
    public static func ft_height() -> CGFloat {
        return self.main.bounds.size.height
    }

}


@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {
    
    
    var window: UIWindow?


    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        window = UIWindow()
        window!.frame  = CGRect(x: 0.0, y: 0.0, width: UIScreen.main.bounds.width, height: UIScreen.main.bounds.height)
        window!.backgroundColor = UIColor.white
        
        
        
        #if DEBUG
            let overlayClass = NSClassFromString("UIDebuggingInformationOverlay") as? UIWindow.Type
            _ = overlayClass?.perform(NSSelectorFromString("prepareDebuggingOverlay"))
            //let overlay = overlayClass?.perform(NSSelectorFromString("overlay")).takeUnretainedValue() as? UIWindow
            //_ = overlay?.perform(NSSelectorFromString("toggleVisibility"))
        #endif

        UITextField.appearance().tintColor = MTColor.main
        UITextView.appearance().tintColor = MTColor.main
        
        if UserDefaults.standard.dictionary(forKey: "launch")  != nil {
            self.window?.rootViewController = ESTabBarController.createTabbar()
        } else {
            let vc = UIStoryboard(name: "Login", bundle: Bundle.main).instantiateVC(GuideViewController.self)!
            self.window?.rootViewController = MTNavigationController(rootViewController: vc)
        }
        self.window?.makeKeyAndVisible()

        return true
    }
    
    func finishGuide() {
        self.window?.rootViewController = ESTabBarController.createTabbar()
    }
    

    
    func applicationWillResignActive(_ application: UIApplication) {
        
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        
    }

    func applicationWillTerminate(_ application: UIApplication) {
        
    }


}


extension AppDelegate {
    
    static var shared: AppDelegate {
        get {
            if let appDelegate = UIApplication.shared.delegate as? AppDelegate {
                return appDelegate
            }
            return AppDelegate()
        }
    }
    
    static var root: UIViewController  {
        get {
            let appDelegate = UIApplication.shared.delegate as! AppDelegate
            return appDelegate.window!.rootViewController!
        }
    }
}

