
import Foundation
import UIKit

public extension UIScrollView {
    
    
    func addRefresh(_ identifier: String, autoRefresh: Bool = true, headerRefresh:@escaping () ->(), footerLoader: (() -> ())? = nil) {
        //let header = ESRefreshHeaderAnimator.init(frame: CGRect.zero)
        let header = MTHeaderAnimator.init(frame: CGRect.zero)
        self.es.addPullToRefresh(animator: header) {
            headerRefresh()
        }
        if let footerBlock = footerLoader {
            let footer = ESRefreshFooterAnimator.init(frame: CGRect.zero)
            self.es.addInfiniteScrolling(animator: footer) {
                footerBlock()
            }
        }
        
        self.refreshIdentifier = identifier
        self.expiredTimeInterval = 30.0
        if autoRefresh {
            DispatchQueue.main.asyncAfter(deadline: .now() + 0.1) { [weak self] in
                self?.es.autoPullToRefresh()
            }
        }
    }
}
