//
//  HistoryViewController.swift
//  News
//
//  Created by Qifeng Xie on 10/04/2019.
//  Copyright © 2019 sct. All rights reserved.
//

import UIKit

class HistoryViewController: MTBaseViewController {

    var datas: [Reading] = []
    
    
    @IBOutlet weak var tableView: UITableView!
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        getDatas()
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        addNavigationBarTitle( "Reading List")
        
    }
    
    func getDatas()  {
        datas = DBManager.default.getReadings()
        tableView.reloadData()
    }
    
    
    func goDetail(_ index: Int) {
        let detail = datas[index]
        let vc = WebViewController(URL(string:  detail.url!)!)
        vc.artcle = Article(reading: detail)
        self.navigationController?.pushViewController(vc, animated: true)
        
    }
    
}


extension HistoryViewController : UITableViewDelegate {
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return UIScreen.main.bounds.width * 2 / 3
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: true)
        goDetail(indexPath.row)
    }
}


extension HistoryViewController : UITableViewDataSource {
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: ReadingCell.className) as! ReadingCell
        cell.info = datas[indexPath.row]
        
        return cell
        
    }
    
}

class ReadingCell: UITableViewCell {
    
    @IBOutlet weak var titleLabel: UILabel!
    @IBOutlet weak var coverImageView: UIImageView!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }
    
    var info: Reading? {
        didSet {
            
            titleLabel.text = info?.title
            if let url = info?.urlToImage {
                coverImageView.kf.setImage(with: URL(string: url))
            }
        }
    }
    
    
}
