//
//  SearchViewController.swift
//  News
//
//  Created by Qifeng Xie on 10/04/2019.
//  Copyright © 2019 sct. All rights reserved.
//

import UIKit


class SearchViewController: MTBaseViewController {

    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)

        self.searchBar.becomeFirstResponder()
    }

    
    @IBOutlet weak var table: UITableView!
    
    var searchBar: UISearchBar!
    
    var datas: [Article] = []
    
    func addSearchBar() {
        addNavigationBarLeftButton(self)
        
        //UIColor *color =  self.navigationController.navigationBar.tintColor;
        //[titleView setBackgroundColor:color];
        
        self.searchBar = UISearchBar(frame: CGRect(x: 30, y: 0, width: UIScreen.main.bounds.width * 180 / 375, height: 40))
        self.searchBar.placeholder = "Enter keywords"
        self.searchBar.backgroundImage = UIImage()
        //self.searchBar.backgroundImage = [UIImage imageNamed:@"sexBankgroundImage"];
        self.searchBar.barTintColor = .red
        self.searchBar.backgroundColor = .clear
        self.searchBar.showsCancelButton = true
        self.searchBar.barStyle = .default
        //self.searchBar.searchBarStyle = UISearchBarStyleMinimal;//没有背影，透明样式
        self.searchBar.delegate = self
        self.navigationItem.titleView = self.searchBar
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()

        addSearchBar()
    }
    
    
    @IBAction func goDetail(_ index: Int) {
        let detail = datas[index]
        let vc = WebViewController(URL(string:  detail.url)!)
        
        vc.artcle = detail
        vc.hidesBottomBarWhenPushed = true
        self.navigationController?.pushViewController(vc, animated: true)
        
    }

}

extension SearchViewController: UISearchBarDelegate {
    func searchBarSearchButtonClicked(_ searchBar: UISearchBar) {
        print("=======================")
        guard let t = searchBar.text else {return }
        Newsapi.getSearchNews(t) { (list) in
            self.datas = list
            self.table.reloadData()
        }
        
    }
    
    func searchBarCancelButtonClicked(_ searchBar: UISearchBar) {
        searchBar.text = nil
        searchBar.resignFirstResponder()
        self.datas = []
        self.table.reloadData()
    }
}


extension SearchViewController : UITableViewDelegate {
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return UIScreen.main.bounds.width * 2 / 3
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: true)
        goDetail(indexPath.row)
    }
}


extension SearchViewController : UITableViewDataSource {
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: ArticleCell.className) as! ArticleCell
        cell.info = datas[indexPath.row]
        
        return cell
        
    }
    
}
