//
//  SubscriptionViewController.swift
//  News
//
//  Created by Qifeng Xie on 10/04/2019.
//  Copyright © 2019 sct. All rights reserved.
//


import UIKit

class SubscriptionViewController: MTBaseViewController {
    
    var datas: [Rss] = []
    
    
    @IBOutlet weak var tableView: UITableView!
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        getDatas()
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        addNavigationBarTitle( "Subscripción")
        
    }
    
    func getDatas()  {
        datas = DBManager.default.getRss()
        tableView.reloadData()
    }
    
    
    func goArtcleListBySource(_ rss: Rss) {
        
        let vc = UIStoryboard.Scene.sourcesNews
        vc.source_id = rss.id
        vc.title = rss.title
        vc.hidesBottomBarWhenPushed = true
        self.navigationController?.pushViewController(vc, animated: true)
        
    }
    
}


extension SubscriptionViewController : UITableViewDelegate {
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 80
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: true)
        goArtcleListBySource(datas[ indexPath.row])
    }
}


extension SubscriptionViewController : UITableViewDataSource {
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return datas.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: RssCell.className) as! RssCell
        cell.info = datas[indexPath.row]
        
        return cell
        
    }
    
}

class RssCell: UITableViewCell {
    
    @IBOutlet weak var titleLabel: UILabel!
    @IBOutlet weak var descLabel: UILabel!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }
    
    var info: Rss? {
        didSet {
            titleLabel.text = info?.title
            descLabel.text = info?.desc
        }
    }
    
    
}
